package Library;

import VisitorLib._

/* Binary Tree example */

object BinaryTree {
    /*
    data Tree {
    	constructor Empty
    	constructor Fork (x : int, l : Tree, r : Tree)
    }
    */
  
    trait TreeVisitor extends Visitor {
      	type Rec = R[TreeVisitor]
      
   		def Empty : X
        def Fork (x : Int, l : R[TreeVisitor],r : R[TreeVisitor]) : X
    }
    
    type Tree = Composite[TreeVisitor]
    
    case object Empty extends Tree {
      def accept[s <: Strategy,x] (vis : VisFunc[TreeVisitor,s,x]) (implicit decompose : Decompose[s]) : x =
        vis.Empty
    }
    
    case class Fork(x : Int, l : Tree, r : Tree) extends Tree {
      def accept[s <: Strategy,x] (vis : VisFunc[TreeVisitor,s,x]) (implicit decompose : Decompose[s]) : x =
        vis.Fork(x,decompose.dec(vis,l),decompose.dec(vis,r))
    }
    
    abstract class CaseTree[s <: Strategy,x](implicit dec : Decompose[s]) extends DCaseTree[s,x](Basic)(dec)   
    
    abstract class DCaseTree[s <: Strategy,x](disp : Dispatcher[TreeVisitor,s,x])(implicit dec : Decompose[s]) 
      extends Case[TreeVisitor,s,x](disp)(dec) with TreeVisitor
}
