package Library;

import VisitorLib._

/* Binary Tree example */

object TipTree {
    // Needs to do breath-search, I think
    trait TreeVisitor extends Visitor {
   		def Tip (x : Int) : X
        def Fork (l : R[TreeVisitor],r : R[TreeVisitor]) : X
    }
    
    type Tree = Composite[TreeVisitor]
    
    case class Tip(x : Int) extends Tree {
      def accept[s <: Strategy,x] (vis : VisFunc[TreeVisitor,s,x]) (implicit decompose : Decompose[s]) : x =
        vis.Tip(x)
    }
    
    case class Fork(l : Tree, r : Tree) extends Tree {
      def accept[s <: Strategy,x] (vis : VisFunc[TreeVisitor,s,x]) (implicit decompose : Decompose[s]) : x =
        vis.Fork(decompose.dec(vis,l),decompose.dec(vis,r))
    }
    
    abstract class CaseTree[s <: Strategy,x](implicit dec : Decompose[s]) extends DCaseTree[s,x](Basic)(dec)   
    
    abstract class DCaseTree[s <: Strategy,x](disp : Dispatcher[TreeVisitor,s,x])(implicit dec : Decompose[s]) 
      extends Case[TreeVisitor,s,x](disp)(dec) with TreeVisitor
}
