package Library;

import VisitorLib._

object TreeForest {
  // data Tree[a] {
  //   constructor Fork (x : a, xs : Forest[a])}
  
  trait TreeVisitor[a] extends Visitor {
    def mrefForest : VisFunc[ForestVisitor[a],S,X]
    
    def Fork (x : a, xs : R[ForestVisitor[a]]) : X
  }
  
  trait Tree[a] extends Composite[TreeVisitor[a]]
  
  abstract class CaseTree[s <: Strategy,a,x](implicit dec : Decompose[s]) extends DCaseTree[s,a,x](Basic)(dec)   
   
  abstract class DCaseTree[s <: Strategy,a,x](disp : Dispatcher[TreeVisitor[a],s,x])(implicit dec : Decompose[s]) 
    extends Case[TreeVisitor[a],s,x](disp)(dec) with TreeVisitor[a]
  
  case class Fork[a](x : a, xs : Forest[a]) extends Tree[a] {
    def accept[s <: Strategy,x] (vis : VisFunc[TreeVisitor[a],s,x]) (implicit decompose : Decompose[s]) : x =
      vis.Fork(x,decompose.dec(vis.mrefForest,xs))
  }
  
  // data Forest[a] {
  //    constructor Nil
  //    constructor (x : Tree[a], xs : Forest[a])}
  trait ForestVisitor[a] extends Visitor {
    def mrefTree : VisFunc[TreeVisitor[a],S,X]
    
    def Nil : X
    def Cons (x : R[TreeVisitor[a]], xs : R[ForestVisitor[a]]) : X
  }
  
  trait Forest[a]  extends Composite[ForestVisitor[a]]
    
  abstract class CaseForest[s <: Strategy,a,x](implicit dec : Decompose[s]) extends DCaseForest[s,a,x](Basic)(dec)   
   
  abstract class DCaseForest[s <: Strategy,a,x](disp : Dispatcher[ForestVisitor[a],s,x])(implicit dec : Decompose[s]) 
    extends Case[ForestVisitor[a],s,x](disp)(dec) with ForestVisitor[a]
  
  case class Nil[a] extends Forest[a] {
    def accept[s <: Strategy,x] (vis : VisFunc[ForestVisitor[a],s,x]) (implicit decompose : Decompose[s]) : x =
      vis.Nil
  }
	
  case class Cons[a](x : Tree[a], xs : Forest[a]) extends Forest[a] {
    def accept[s <: Strategy,x] (vis : VisFunc[ForestVisitor[a],s,x]) (implicit decompose : Decompose[s]) : x =
      vis.Cons(decompose.dec(vis.mrefTree,x),decompose.dec(vis,xs))
  }
}