package Library;

import VisitorLib._
import TreeForest._
import InternalVisitors._

// Mutually recursive types are not a problem

object TreeForestTest {
  // Using Internal visitors
  def sumTree : CaseTree[Internal,Int,Int] = new CaseTree[Internal,Int,Int] {
    def mrefForest = sumForest
    
    def Fork (x : Int, xs : Int)  = x + xs
  }
  
  def sumForest : CaseForest[Internal,Int,Int] = new CaseForest[Internal,Int,Int] {
    def mrefTree = sumTree
    
    def Nil                        = 0
    def Cons (x : Int, xs : Int)   = x + xs
  }
  
  // Using external visitors
  def sumEven2 : CaseTree[External,Int,Int] = new CaseTree[External,Int,Int] {
    def mrefForest = sumOdd2
    
    def Fork (x : Int, xs : R[ForestVisitor[Int]])  = x + mrefForest(xs)
  }
  
  def sumOdd2 : CaseForest[External,Int,Int] = new CaseForest[External,Int,Int] {
    def mrefTree = sumEven2
    
    def Nil                                                          = 0
    def Cons (x : R[TreeVisitor[Int]], xs : R[ForestVisitor[Int]])   = mrefTree(x) + sumOdd2(xs)
  }
  
  val t  = Fork(9,Cons(Fork(3,Nil[Int]),Nil[Int]))
  
  def test = sumTree(t)
}
