package both

import Library.InternalVisitors._
import Library.VisitorLib._

// Ad-hoc assemblage of components
object Client {
  protected val C = Components
  
  // Defining the members of the datatype
  type Expr                    = C.Expr[ExprShape]
  
  // Shorthand for NumAdd Visitors
  trait ExprShape extends C.vnum with C.vadd[ExprShape]
  
  // Shorthands for the constructors
  def Num(x : Int)               = C.Num[ExprShape](x)
  def Add(e1 : Expr, e2 : Expr)  = C.Add[ExprShape](e1,e2)
  
  object evalVis extends C.BaseEval[ExprShape] with ExprShape
  object printVis extends C.BasePrint[ExprShape] with ExprShape
  
  // The operations
  def eval(e : Expr) : Int = e.accept(evalVis)
  def print(e : Expr) : String = e.accept(printVis)
  
  val exp = Add(Num(3),Num(10))
  
  val test = eval(exp)
}