package external

object EqualityClient {
  val C=Components
  val EC=ExtendedComponents
  
  type ExprShape[-R,A]  = C.vnum[R,A] with C.vadd[R,A] 
  type Expr             = C.Expr[ExprShape]
  
  trait EqualsDefault[A] extends EC.AddHandleDefault[ExprShape,A] with EC.NumHandleDefault[ExprShape,A] {
      self : ExprShape[Expr,A => Boolean] =>
  }
  
  // Tying up the recursion knots
  object equalsNum extends EqualsDefault[Int] with EC.HandleNum[ExprShape] {
    val eqVis=equalsVis
  }
  
  object equalsAdd extends EqualsDefault[EC.Tuple[ExprShape]] with EC.HandleAdd[ExprShape] {
    val eqVis=equalsVis
  }
  
  object equalsVis extends EC.NumEquals[ExprShape] with EC.AddEquals[ExprShape] {
    val eqNum=equalsNum
    val eqAdd=equalsAdd
  }
  
  def equal(e1 : Expr, e2 : Expr) : Boolean = e1.accept(equalsVis)(e2)
  
  // Shorthands for the constructors
  def Num(x : Int)               = C.Num[ExprShape](x)
  def Add(e1 : Expr, e2 : Expr)  = C.Add[ExprShape](e1,e2)
  
  val exp1 = Add(Add(Num(3),Num(4)),Num(10))
  val exp2 = Num(17)
  
  val test=equal(exp1,exp2)
}
