package internal

import Components._

object NegationComponents {
  // Components for Negation
  trait vneg[A] {
    def neg(e : A) : A
  }
    
  case class Neg[-V[X] <: vneg[X]](e : Expr[V]) extends Expr[V] {
    def accept[a](vis : V[a]) : a = vis.neg(e.accept(vis))
  }
  
  // 2 alternatives for extending Evaluation to the new variant
  trait NegEval extends vneg[Int] {
    def neg(e : Int) = -e
  }
  
  trait NegEval2 extends BaseEval with vneg[Int] {
    def neg(e : Int) = -e
  }
}
