package internal

import Components._
import NegationComponents._
import MinusComponents._

object SimplifyComponent {
  // This function should be separately defined, because otherwise it hinders composability
  
  // A function that restricts the domain
  trait Narrow[V[X] <: vnum[X] with vadd[X] with vminus[X]] extends 
   vnum[Expr[V]] with vadd[Expr[V]] with vneg[Expr[V]] {
    def num(x : Int)                     = Num[V](x)
    def add(e1 : Expr[V], e2 : Expr[V])  = Add[V](e1,e2)
    def neg(e : Expr[V])                 = Minus[V](Num[V](0),e) //this is a type error: Neg[V](e) 
  }
  
  // More reusable
  trait NumNarrow[V[X] <: vnum[X]] extends vnum[Expr[V]] {
    def num(x : Int)                     = Num[V](x)
  }
  
  trait AddNarrow[V[X] <: vadd[X]] extends vadd[Expr[V]] {
    def add(e1 : Expr[V], e2 : Expr[V])  = Add[V](e1,e2)
  }
  
  trait NegNarrow[V[X] <: vneg[X]] extends vneg[Expr[V]] {
    def neg(e : Expr[V]) = Neg[V](e)
  }
  
  trait NMNarrow[V[X] <: vnum[X] with vminus[X]] extends vneg[Expr[V]] {
    def neg(e : Expr[V])                 = Minus[V](Num[V](0),e)
  }
  
  type numminus[X] = vnum[X] with vminus[X]
  
  object myNarrow extends NumNarrow[vnum] with AddNarrow[vadd] with NMNarrow[numminus]
}
